package com.jiayue.ipfcst.common.data.abst;

import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.core.annotation.Order;

import javax.persistence.Column;
import javax.persistence.MappedSuperclass;
import javax.validation.constraints.Digits;
import java.math.BigDecimal;

/**
 * 实时预测功率抽象实体
 *
 * @author zzy
 * @version 1.0
 * @since 2019/11/28 16:04
 */
@EqualsAndHashCode(callSuper = true)
@Data
@MappedSuperclass
public class AbstractForecastPower
		extends AbstractForecastPowerBase {

	/**
	 * 预测功率（MW）
	 */
	@Order(20)
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal fpValue;


}
