package com.jiayue.ipfcst.common.data.abst;

import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.core.annotation.Order;

import javax.persistence.Column;
import javax.persistence.MappedSuperclass;
import javax.validation.constraints.Digits;
import java.math.BigDecimal;

/**
 * 上报预测功率抽象实体
 *
 * @author zzy
 * @version 1.0
 * @since 2019/11/28 16:05
 */
@EqualsAndHashCode(callSuper = true)
@Data
@MappedSuperclass
public class AbstractForecastPowerHis extends AbstractForecastPowerBase {

	/**
	 * 可用预测功率（MW）
	 */
	@Order(10)
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal ableValue;

	/**
	 * 理论预测功率（MW）
	 */
	@Order(11)
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal theoryValue;

	/**
	 * 开机容量（MW）
	 */
	@Order(12)
	@Column
	@Digits(integer = 10, fraction = 2)
	private BigDecimal suCapacity;

	/**
	 * 装机容量（MW）
	 */
	@Order(13)
	@Column
	@Digits(integer = 10, fraction = 2)
	private BigDecimal capacity;

	/*提前多久预测*/
	@Column
	private Integer forecastHowLongAgo;
}
