package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.equipmentstatus.AbstractEquipmentStatusData;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.Entity;
import java.math.BigDecimal;

/**
 * AGC和AVC的状态数据
 *
 * @author: xiuwei
 * @version:
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class AGC_AVCStatusData extends AbstractEquipmentStatusData {


	/**
	 * 全场出力上限 MW
	 */
	BigDecimal upperLimitOfWholeStation;
	/**
	 * 全厂出力下限	KW
	 */
	BigDecimal lowerLimitOfWholeStation;
	/**
	 * 全场响应速率	 MW/min
	 */
	BigDecimal speedRateOfWholeStation;
	/**
	 * 全场目标定值返回值 MW
	 */
	BigDecimal targetValueOfWholeStation;
	/**
	 * AGC投/退
	 */
	Boolean AGCOnOrOff;
	/**
	 * AGC远方/就地
	 */
	Boolean AGCRemoteOrOnTheSpot;
	/**
	 * AGC增出力闭锁
	 */
	Boolean AGCIncreaseOutputAtresia;
	/**
	 * AGC减出力闭锁
	 */
	Boolean AGCDecreaseOutputAtresia;
	/**
	 * 升压变高压侧母线电压上限值  KV
	 */
	BigDecimal upperLimitOfBoosterHighPressureSideBusVoltage;
	/**
	 * 升压变高压侧母线电压下限值  KV
	 */
	BigDecimal lowerLimitOfBoosterHighPressureSideBusVoltage;
	/**
	 * AVC投/退
	 */
	Boolean AVCOnOrOff;
	/**
	 * AVC远方/就地
	 */
	Boolean AVCRemoteOrOnTheSpot;
	/**
	 * AVC增出力闭锁
	 */
	Boolean AVCIncreaseOutputAtresia;
	/**
	 * AVC减出力闭锁
	 */
	Boolean AVCDecreaseOutputAtresia;


}
