package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;
import org.springframework.core.annotation.Order;

import javax.persistence.*;

/**
 * 准确率合格率
 *
 * @author yh
 * @version 1.0
 * @since 2020/7/8 10:56
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
@ApiModel("光伏准确率合格率实体类")
public class AccuracyPassRate extends AbstractBaseEntity {
    @Id
    @Order(1)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    @ApiModelProperty("主键")
    private Integer id;

    //时间
    @Column
    @ApiModelProperty("统计时间")
    private Long time;

    //短期准确率
    @Column
    @ApiModelProperty("短期准确率")
    private String shortTermAccuracy;

    //短期合格率
    @Column
    @ApiModelProperty("短期合格率")
    private String shortTermPassRate;

    //超短期准确率
    @Column
    @ApiModelProperty("超短期准确率")
    private String ultraShortTermAccuracy;

    //超短期合格率
    @Column
    @ApiModelProperty("超短期合格率")
    private String ultraShortTermPassRate;

    //中期准确率
    @Column
    private String midTermAccuracy;

    //中期合格率
    @Column
    private String midTermPassRate;

}
