package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.math.BigDecimal;

/**
 * 数据限制实体
 *
 * @author tl
 * @version 3.0
 * @since 2021/1/5 11:20
 */
@EqualsAndHashCode(callSuper = true)
@Entity
@Data
public class DataLimitation  extends AbstractBaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    @Column
    private Integer id;

    /**
     * 被限制时间点
     */
    @Column
    private Long limitTime;

    /**
     * 上限值
     */
    @Column
    private BigDecimal upperLimit;

    /**
     * 下限值
     */
    @Column
    private BigDecimal lowerLimit;

}
