package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;

/**
 * 数据限制记录
 *
 * @author tl
 * @version 3.0
 * @since 2021/1/5 11:21
 */
@EqualsAndHashCode(callSuper = true)
@Entity
@Data
public class DataLimitationLog extends AbstractBaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    @Column
    private Integer id;

    /**
     * 操作时间
     */
    @Column
    private Long operationalTime;
    /**
     * 操作内容
     */
    @Lob
    @Column
    private String operationalContext;
    /**
     * 操作类型 （0新增 1修改 2删除）
     */
    @Column
    private Integer operationalStatus;

    /**
     * 被限制时间
     */
    @Column
    private Long limitTime;
}
