package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;

/**
 * 展示配置实体
 *
 * @author yh
 * @version 1.0
 * @since 2019/7/22 11:16
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
@ApiModel("展示配置实体")
public class DisplayConfig extends AbstractBaseEntity {

    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    @Id
    @Column
    private Integer id;

    /**
     * 展示配置编码
     */
    @Column
    @ApiModelProperty("展示配置编码")
    private String displayCode;

    /**
     * 展示字段
     */
    @Column(columnDefinition = "varchar(2000) default 'LTD' not null")
    @ApiModelProperty("展示字段")
    private String showCode;

    /**
     * 隐藏字段
     */
    @Column(columnDefinition = "varchar(2000) default 'LTD' not null")
    @ApiModelProperty("隐藏字段")
    private String hiddenCode;

}
