package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;
import org.springframework.core.annotation.Order;

import javax.persistence.*;

/**
 * 文件解析记录
 *
 * @author cuil
 * @version 2.0
 * @since 2018/12/29 15:21
 */
@EqualsAndHashCode(callSuper = true)
@Entity
@Data
public class FileAnalysisRecord extends AbstractBaseEntity {
    @Id
    @Order(1)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    private Integer id;
    /*文件名称*/
    @Column
    private String fileTitle;
    /*文件类型 */
    @Column
    private String fileType;
    /*文件描述*/
    @Column(length = 256)
    private String fileDescription;
    /*文件存放路径*/
    @Column(length = 256)
    private String filePath;
    /*文件解析状态 1:成功 0:失败*/
    @Column
    private String fileStatus;

    // 高精度数据使用   @Digits(integer = 5, fraction = 2) @Column private BigDecimal weight;

}
