package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractForecastPowerHis;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.Entity;
import javax.persistence.Transient;
import java.math.BigDecimal;

/**
 * 短期预测功率实体
 *
 * @author zzy
 * @version 1.0
 * @since 2018/10/23 9:17
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class ForecastPowerShortTermHis extends AbstractForecastPowerHis {

	/**
	 * ------------------------------------华北直调上报字段，不写入数据库--------------------------------------------
	 */

	//风速
	@Transient
	private BigDecimal windspeed;
	//风向
	@Transient
	private BigDecimal windDir;
	//气温
	@Transient
	private BigDecimal temperature;
	//相对湿度
	@Transient
	private BigDecimal humidity;
	//压力
	@Transient
	private BigDecimal pressure;
	//经度
	@Transient
	private BigDecimal longitude;
	//纬度
	@Transient
	private BigDecimal latitude;
}
