package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractForecastPower;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.core.annotation.Order;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.validation.constraints.Digits;
import java.math.BigDecimal;

/**
 * 超短期预测功率实体
 *
 * @author zzy
 * @version 1.0
 * @since 2019/8/1 10:56
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class ForecastPowerUltraShortTerm extends AbstractForecastPower {
    /**
     * 由差值计算出来的超短期（MW）
     */
    @Order(20)
    @Digits(integer = 10, fraction = 2)
    @Column
    private BigDecimal DifferenceValue;

    /**
     * 由短期*系数计算出来的超短期（MW）
     */
    @Order(20)
    @Digits(integer = 10, fraction = 2)
    @Column
    private BigDecimal CoefficientValue;
}
