package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.equipmentinfo.AbstractEquipmentInfo;
import com.jiayue.ipfcst.common.data.constant.enums.EquipmentTypeEnum;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.validation.constraints.Digits;
import java.math.BigDecimal;

/**
 * 逆变器实体
 *
 * @author zzy
 * @version 1.0
 * @since 2019/8/2 10:12
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class InverterInfo extends AbstractEquipmentInfo {

    public InverterInfo() {
        super.setEquipmentType(EquipmentTypeEnum.INVERTER);
    }
    /**
     * 备用字段A 应用于样板机编号
     */
    /**
     * 逆变器名称
     */
    @Column
    private String name;

    /**
     * 是否组串式
     */
    @Column
    private Boolean groupSeries;

    /**
     * 逆变器效率（%）
     */
    @Digits(integer = 5, fraction = 2)
    @Column
    private BigDecimal efficiency;

    /**
     * 额定功率（KW）
     */
    @Digits(integer = 10, fraction = 2)
    @Column
    private BigDecimal capacity;

    /**
     * 箱式变压器
     */
    @Column
    private String box;

    /**
     * 集电线路
     */
    @Column
    private String collectorCircuit;


    /**
     * 光伏组件型号
     */
    @Column
    private String batteryModel;

    /**
     * 光伏组件数量（个）
     */
    @Column
    private Integer batteryNumber;

    /*   *//**
     * 光伏阵列的倾斜角（°）
     *//*
    @Column
    private Float pvArrayAngle;

    *//**
     * 光伏阵列的方位（°），方位角为零。正南为0，正西为90，正北180，正东270
     *//*
    @Column
    private Float pvPosition;

    *//**
     * 光伏组件旋转方式
     *//*
    @Column
    private PvRotationModeEnum pvRotationModeEnum;
*/
    /**
     * 逆变器是否样板机
     */
    @Column
    private Boolean sample;

    /**
     * backupA 样板机编号
     */

    /**
     * backupB 经度
     */

    /**
     * backupC 纬度
     */
}
