package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.equipmentstatus.AbstractEquipmentStatusData;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.validation.constraints.Digits;
import java.math.BigDecimal;

/**
 * 逆变器数据实体
 *
 * @author zzy
 * @version 1.0
 * @since 2019/7/22 11:21
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class InverterStatusData extends AbstractEquipmentStatusData {


	/**
	 * 有功（KW）
	 */
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal activePower = new BigDecimal(-99);

	/**
	 * 无功（KVar）
	 */
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal reactivePower = new BigDecimal(-99);

	/**
	 * 功率因数
	 */
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal powerFactor = new BigDecimal(-99);

	/**
	 * 电压（V）
	 */
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal voltage = new BigDecimal(-99);


	/**
	 * 电流（A）
	 */
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal electricalCurrent = new BigDecimal(-99);

	/**
	 * 当日发电量（kW·h）
	 */
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal dayElectricQuantity = new BigDecimal(-99);


	/**
	 * 累积发电量（MW·h）
	 */
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal cumulativeGeneratedEnergy  = new BigDecimal(-99);

	/**
	 * 当日并网小时
	 */
	@Digits(integer = 10, fraction = 2)
	@Column
	private BigDecimal dayGridConnectedHours = new BigDecimal(-99);


}
