package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.math.BigDecimal;

/**
 * 人工干预数据实体
 *
 * @author tl
 * @version 3.0
 * @since 2020/9/21 11:02
 */
@EqualsAndHashCode(callSuper = true)
@Entity
@Data
public class ManualInterventionData extends AbstractBaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    @Column
    private Integer id;

    /**
     * 被干预时间点
     */
    @Column
    private Long interveneTime;
    /**
     * 干预后的值
     */
    @Column
    private BigDecimal interveneData;
    /**
     * 干预的文件类型
     */
    @Column(length = 64)
    private String interveneType;


}
