package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;

/**
 * 人工干预数据日志
 *
 * @author tl
 * @version 3.0
 * @since 2020/9/21 11:02
 */
@EqualsAndHashCode(callSuper = true)
@Entity
@Data
public class ManualInterventionLog extends AbstractBaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    @Column
    private Integer id;

    /**
     * 文件类型
     */
    @Column(length = 64)
    private String fileType;
    /**
     * 操作时间
     */
    @Column
    private Long operationalTime;
    /**
     * 操作内容
     */
    @Lob
    @Column()
    private String operationalContext;
    /**
     * 操作类型 （0新增 1修改 2删除 3系数新增 4系数删除 5修改负偏差 ）
     */
    @Column()
    private Integer operationalStatus;
    /**
     * 被干预时间
     */
    @Column()
    private Long interveneTime;
}
