package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import javax.validation.constraints.Digits;
import java.math.BigDecimal;

/**
 * 人工干预系数数据实体
 *
 * @author tl
 * @version 3.0
 * @since 2020/9/21 11:02
 */
@EqualsAndHashCode(callSuper = true)
@Entity
@Data
public class ManualInterventionRatioData extends AbstractBaseEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    @Column
    private Integer id;

    /**
     * 被干预开始时间
     */
    @Column
    private Long interveneStartTime;
    /**
     * 被干预截止时间
     */
    @Column
    private Long interveneEndTime;
    /**
     * 干预后的值
     */
    @Column
    @Digits(integer = 2, fraction = 2)
    private BigDecimal ratio;
    /**
     * 干预的文件类型
     */
    @Column(length = 64)
    private String interveneType;


}
