package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import com.jiayue.ipfcst.common.data.constant.enums.FileTypeEnum;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.util.Date;

/**
 * 手动上传文件记录
 *
 * @author zzy
 * @version 1.0
 * @since 2019/7/22 11:24
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class ManualUploadLog extends AbstractBaseEntity {


    /**
     * 编号
     */
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    @Column
    private Integer id;


    /**
     * 上报对象主键ID
     */
    @Column
    private Integer uploadObjectId;

    /**
     * 上传时间
     */
    @Column
    private Date uploadDate;

    /**
     * 上传目录
     */
    @Column
    private String uploadCatalog;

    /**
     * 上报对象名称
     */
    @Column
    private String uploadObjectName;

    /**
     * 上报对象编号
     */
    @Column
    private String uploadObjectNo;

    /**
     * 文件名称
     */
    @Column
    private String fileName;

    /**
     * 文件类型
     */
    @Column
    @Enumerated(EnumType.STRING)
    private FileTypeEnum fileTypeEnum;


    /**
     * 上报设备ID(指定气象站或测风塔)
     */
    @Column
    private String uploadEquipmentID;


}
