package com.jiayue.ipfcst.common.data.entity;

import lombok.Data;
import org.hibernate.annotations.GenericGenerator;
import org.springframework.core.annotation.Order;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
 * pr值实体类
 *
 * @author fxy
 * @version 1.0
 * @since 2022/10/13 10:56
 */
@Data
@Entity
public class PrValue {
    @Id
    @Order(1)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    private Integer id;

    /**
     * 理论发电量 (MW)
     */
    @Column
    private BigDecimal theoreticalPowerGeneration = new BigDecimal(-99);

    /**
     * 开机容量（MW）
     */
    @Column
    private BigDecimal capacity = new BigDecimal(-99);

    /**
     * 日照小时数
     */
    @Column
    private BigDecimal hourDA = new BigDecimal(-99);

    /**
     * 系统效率
     */
    @Column
    private BigDecimal ultraShortTermAccuracy = new BigDecimal(-99);

    /**
     * pr值 （%）
     */
    @Column(columnDefinition = "decimal(19,5)")
    private BigDecimal prValue = new BigDecimal(-99);

    /**
     * 实际发电量 （MW）
     */
    @Column
    private BigDecimal actualPowerGeneration = new BigDecimal(-99);

    /**
     * 时间
     */
    @Column
    private Date time;

}
