package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;
import org.springframework.core.annotation.Order;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 一体化检修实体
 *
 * @author tl
 * @version 3.0
 * @since 2022/11/02 11:29
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class RepairPlan extends AbstractBaseEntity {

    @Id
    @Order(1)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    private Integer id;

    /**
     * 解析时间
     */
    @Column
    private Date parseTime;


    /**
     * 开始时间
     */
    @Column
    private Date startTime;

    /**
     * 结束时间
     */
    @Column
    private Date endTime;

    /**
     * 检修容量
     */
    @Column
    private BigDecimal capacityCurtailment;


}
