package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;
import org.springframework.core.annotation.Order;

import javax.persistence.*;

/**
 * 参数实体
 *
 * @author bizy
 * @version 1.0
 * @since 2018/10/22 11:29
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class SysParameter extends AbstractBaseEntity {

    @Id
    @Order(1)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    private Integer id;

    /**
     * 参数标识
     */
    @Column(unique = true)
    private String sysKey;

    /**
     * 参数值
     */
    @Column
    private String sysValue;

    /**
     * 参数描述
     */
    @Column
    private String describe;

    /**
     * 场站标识
     */
    @Column
    private String stationCode;

}
