package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;
import org.springframework.core.annotation.Order;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 一体化系数实体
 *
 * @author bizy
 * @version 1.0
 * @since 2018/10/22 11:29
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class UltraShortTermCoefficient extends AbstractBaseEntity {

    @Id
    @Order(1)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    private Integer id;

    /**
     * 解析时间
     */
    @Column
    private Date parseTime;

    /**
     * 时间
     */
    @Column
    private Date time;

    /**
     * 短期修正比例
     */
    @Column
    private BigDecimal coefficient;


}
