package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.constant.enums.FileTypeEnum;
import lombok.Data;
import org.hibernate.annotations.GenericGenerator;
import org.springframework.core.annotation.Order;

import javax.persistence.*;

/**
 * 上报文件CODE码
 *
 * @author xsl
 * @version 3.0
 */
@Data
@Entity
public class UploadFileCode {
    private static final long serialVersionUID = 1L;

    @Id
    @Order(1)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    private Integer id;

    /**
     * 上报文件类型
     */
    @Column
    @Enumerated(EnumType.STRING)
    private FileTypeEnum fileTypeEnum;

    /**
     * 102文件CODE码
     */
    @Column
    private Integer fileTypeCode;

    @Column
    private String stationCode;
}
