package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;
import org.springframework.core.annotation.Order;

import javax.persistence.*;

/**
 * 所有上报文件类型code
 *
 * @author xsl
 * @version 3.0
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class UploadFileType extends AbstractBaseEntity {

    private static final long serialVersionUID = 1L;

    @Id
    @Order(1)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    private Integer id;

    /**
     * 上报省调名称
     */
    @Column
    private String provinceName;

    /**
     * 上报省调枚举
     */
    @Column
    private String provinceEnum;
    /**
     * 文件类型名称
     */
    @Column
    private String fileTypeName;

    /**
     * 文件类型枚举
     */
    @Column
    private String fileTypeEnum;
    /**
     * 上报code码
     */
    @Column
    private String uploadCode;
}
