package com.jiayue.ipfcst.common.data.entity;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import com.jiayue.ipfcst.common.data.constant.enums.*;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;
import org.springframework.core.annotation.Order;

import javax.persistence.*;


/**
 * 上报信息
 *
 * @author tl
 * @version 3.0
 */
@EqualsAndHashCode(callSuper = true)
@Entity
@Data
public class UploadInfo extends AbstractBaseEntity {

    private static final long serialVersionUID = 1L;

    @Id
    @Order(1)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    private Integer id;

    /**
     * 省调
     */
    @Column
    private String provinceEnum;

    /**
     * 场站名称
     */
    @Column
    private String elName;

    /**
     * 对象名称
     */
    @Column
    private String uploadObjectName;

    /**
     * 上报文件类型
     */
    @Column
    private String fileType;

    /**
     * 字符集
     */
    @Column
    private String uploadFileCharSetEnum;

    /**
     * 通道名称
     */
    @Column
    private String channelName;

    /**
     * 上报文件名称长度
     */
    @Column
    private String uploadFileNameLengthEnum;

    /**
     * 上报文件单次传输字节
     */
    @Column
    private String uploadFileSingleByteEnum;

    /**
     * 上报协议
     */
    @Column
    private String uploadProtocolEnum;
}
