package com.jiayue.ipfcst.common.data.entity.integration;

import com.jiayue.ipfcst.common.data.abst.AbstractForecastPower;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.core.annotation.Order;
import org.springframework.data.annotation.CreatedDate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.Digits;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @description: 一体化短期实时表
 * @author: yuanhao
 * @createDate: 2021/8/23
 * @version: 1.0
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class InForecastPowerShortTermHis extends AbstractForecastPower {

    /**
     * 总辐射
     */
    @Order(21)
    @Column
    @Digits(integer = 10, fraction = 2)
    private BigDecimal swr = new BigDecimal(-99);

    /**
     * 直辐射
     */
    @Order(22)
    @Column
    @Digits(integer = 10, fraction = 2)
    private BigDecimal directRadiation = new BigDecimal(-99);
    /**
     * 散辐射
     */
    @Order(23)
    @Column
    @Digits(integer = 10, fraction = 2)
    private BigDecimal diffuseRadiation = new BigDecimal(-99);
    //风速
    @Order(24)
    @Digits(integer = 10, fraction = 2)
    @Column
    private BigDecimal windspeed;
    //风向
    @Order(25)
    @Digits(integer = 10, fraction = 2)
    @Column
    private BigDecimal windDir;
    //气温
    @Order(26)
    @Digits(integer = 10, fraction = 2)
    @Column
    private BigDecimal temperature;
    //相对湿度
    @Order(27)
    @Digits(integer = 10, fraction = 2)
    @Column
    private BigDecimal humidity;
    //压力
    @Order(28)
    @Digits(integer = 10, fraction = 2)
    @Column
    private BigDecimal pressure;

    /*提前多久预测*/
    @Order(29)
    @Column
    private Integer forecastHowLongAgo;
    /**
     * 生成文件日期
     */
    @Order(30)
    @Temporal(TemporalType.TIMESTAMP)
    @CreatedDate
    @Column
    private Date createDate;
}
