package com.jiayue.ipfcst.common.data.entity.integration;

import com.jiayue.ipfcst.common.data.abst.AbstractBaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.GenericGenerator;
import org.springframework.core.annotation.Order;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 * @description:
 * @author: yuanhao
 * @createDate: 2021/8/26
 * @version: 1.0
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
public class IntegrationRecord extends AbstractBaseEntity {

    @Id
    @Order(1)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "myid")
    @GenericGenerator(name = "myid", strategy = "com.jiayue.ipfcst.common.data.entity.id.CustomIDGenerator")
    private Integer id;
    /**
     * 数据类型
     */
    private String type;

    /**
     * 时间
     */
    private Long time;
    /**
     * 上下午
     */
    private String amPm;

    /**
     * 文件名
     */
    private String fileName;

    /**
     * 请求上送数据时间
     */
    private String  upTime;

    /**
     * 请求上送是否成功
     */
    private String upStatus;
    /**
     * 请求修正下载时间
     */
    private String correctTime;
    /**
     * 请求修正下载是否成功
     */
    private String correctStatus;

    /**
     * 数据是否上报状态
     */
    private String status;
}
