package com.jiayue.ipfcst.common.data.repository;


import com.jiayue.ipfcst.common.data.entity.ForecastPowerUltraShortTermOne;

import java.io.Serializable;
import java.util.List;

/**
 * 实时超短期预测数据实体
 *
 * @author zzy
 * @version 1.0
 * @since 2019/8/2 12:53
 */
public interface ForecastPowerUltraShortTermOneRepository extends BaseRepository<ForecastPowerUltraShortTermOne, Serializable> {

	/**
	 * 根据预测时间段查询预测数据
	 *
	 * @param stTime 开始时间
	 * @param eTime  结束时间
	 * @return 超短期预测数据集合
	 */
	List<ForecastPowerUltraShortTermOne> deleteByForecastTimeBetween(Long stTime, Long eTime);

	/**
	 * 按时间段查询数据
	 *
	 * @param startTime
	 * @param endTime
	 */
	List<ForecastPowerUltraShortTermOne> findByForecastTimeBetween(Long startTime, Long endTime);
}
