package com.jiayue.ipfcst.common.data.repository;


import com.jiayue.ipfcst.common.data.entity.PowerStationStatusData;
import com.jiayue.ipfcst.common.data.repository.BaseRepository;

import java.util.Date;
import java.util.List;

/**
 * 实际功率仓储
 *
 * @author zzy
 * @version 1.0
 * @since 2019/8/6 12:42
 */
public interface PowerStationStatusDataRepository extends BaseRepository<PowerStationStatusData, Integer> {
	/**
	 * 按时间段查询数据
	 *
	 * @param startTime 开始时间
	 * @param endTime 结束时间
	 * @return 结果集
	 */

	List<PowerStationStatusData> findByTimeBetween(Date startTime, Date endTime);
	/**
	 * 按时间段查询数据
	 *
	 * @param queryTime 开始时间
	 * @return 结果集
	 */
	PowerStationStatusData findByTime(Date queryTime);
}
