package com.jiayue.ipfcst.common.data.repository;

import com.jiayue.ipfcst.common.data.entity.SendLog;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import java.util.Date;
import java.util.List;
/**
 * 回传日志实体仓储
 *
 * @author zy
 * @version 1.0
 * @since 2021/4/21
 */
public interface SendLogRepository  extends BaseRepository<SendLog, Integer>{
    /**
     * 分页查询
     * @param startTime     开始时间
     * @param endTime       结束时间
     * @param pageable      分页信息
     * @param tunnelId      通道id
     * @return
     */
    Page<SendLog> findByCreateTimeBetweenAndTunnelId(Date startTime, Date endTime, String tunnelId , Pageable pageable);

    /**
     * 分页查询
     * @param startTime     开始时间
     * @param endTime       结束时间
     * @param pageable      分页信息
     * @return
     */
    Page<SendLog> findByCreateTimeBetween(Date startTime, Date endTime , Pageable pageable);

    List<SendLog> findByCreateTimeBetweenAndTunnelId(Date startTime, Date endTime, String tunnelId);
}
