package com.jiayue.ipfcst.common.data.repository;

import com.jiayue.ipfcst.common.data.entity.WeatherStationStatusData;
import com.jiayue.ipfcst.common.data.repository.BaseRepository;

import java.util.Date;
import java.util.List;

/**
 * 环境检测仪数据实体仓储
 *
 * @author zzy
 * @version 1.0
 * @since 2019/8/6 13:10
 */
public interface WeatherStationStatusDataRepository extends BaseRepository<WeatherStationStatusData, Integer> {
	/**
	 * 按时间段设备编号查询数据并按时间正序排序
	 * yh
	 *
	 * @param startTime 开始时间
	 * @param endTime   结束时间
	 * @param no        设备编号
	 */
	List<WeatherStationStatusData> findByTimeBetweenAndEquipmentNo(Date startTime, Date endTime, Integer no);

	/**
	 * 按时间段查询数据并按时间正序排序
	 * yh
	 *
	 * @param startTime 开始时间
	 * @param endTime   结束时间
	 */
	List<WeatherStationStatusData> findByTimeBetween(Date startTime, Date endTime);
}
