import Layout from '@/layout'

const dataExchangeRouter = {
  path: '/dataExchange',
  component: Layout,
  redirect: 'noRedirect',
  name: 'DataExchange',
  meta: {
    title: '数据交互中心',
    icon: 'tree'
  },
  children: [
    {
      path: 'equipmentAttribute',
      component: () => import('@/views/dataexchange/equipmentAttribute'),
      name: 'equipmentAttribute',
      meta: {title: '设备状态属性', noCache: true},
      sign: 'currency'
    },
    {
      path: 'gatherdatapoint',
      component: () => import('@/views/dataexchange/gatherdatapoint'),
      name: 'gatherdatapoint',
      meta: {title: '通道采集点表', noCache: true},
      sign: 'currency'
    },
    {
      path: 'senderdatapoint',
      component: () => import('@/views/dataexchange/senderdatapoint'),
      name: 'senderdatapoint',
      meta: {title: '通道转发点表', noCache: true},
      sign: 'currency'
    },
    {
      path: 'template',
      component: () => import('@/views/dataexchange/template'),
      name: 'template',
      meta: {title: '模版信息', noCache: true},
      sign: 'currency'
    },
    {
      path: 'templatedatapoint',
      component: () => import('@/views/dataexchange/templatedatapoint'),
      name: 'templatedatapoint',
      meta: {title: '模版点表', noCache: true},
      hidden:true,
      sign: 'currency'
    },
    {
      path: 'tunnelinfo',
      component: () => import('@/views/dataexchange/tunnelinfo'),
      name: 'tunnelinfo',
      meta: {title: '通道信息', noCache: true},
      sign: 'currency'
    },
    {
      path: 'sendLog',
      component: () => import('@/views/dataexchange/sendLog'),
      name: 'sendLog',
      meta: {title: '回传日志', noCache: true},
      sign: 'currency'
    }
  ]
}

export default dataExchangeRouter
