/** When your routing table is too long, you can split it into small modules**/

import Layout from '@/layout'

const systemRouter = {
    path: '/system',
    component: Layout,
    redirect: '/system/quartz',
    name: 'system',
    meta: {
        title: '系统管理',
        icon: 'system'
    },
    children: [
        // {
        //     path: 'jobClass',
        //     component: () => import('@/views/quartz/JobClass/index'),
        //     name: 'jobClass',
        //     meta: {title: '定时任务初始化', noCache: true},
        //     sign: 'currency'
        // },
        {
            path: 'quartz',
            component: () => import('@/views/quartz/index'),
            name: 'quartz',
            meta: {title: '定时任务', noCache: true},
            sign: 'currency'
        },
        {
            path: 'systemfile',
            component: () => import('@/views/systemfile/LogFile'),
            name: 'systemfile',
            meta: {title: '系统文件', noCache: true},
            sign: 'currency'
        },
        {
            path: 'systemuser',
            component: () => import('@/views/console/sysUser/index'),
            name: 'systemuser',
            meta: {title: '用户管理', noCache: true},
            sign: 'admin'
        }
    ]
}

export default systemRouter
