/** When your routing table is too long, you can split it into small modules**/

import Layout from '@/layout'

const uploadRouter = {
  path: '/uploadFile',
  component: Layout,
  redirect: '/uploadFile/uploadFileChannel',
  name: 'uploadFile',
  meta: {
    title: '文件上报',
    icon: 'form'
  },
  children: [
    {
      path: 'uploadFileChannel',
      component: () => import('@/views/uploadFile/UploadFileChannel'),
      name: 'UploadFileChannel',
      meta: {title: '上报通道配置', noCache: true},
      sign: 'currency'
    },
    {
      path: 'queryUploadFile',
      component: () => import('@/views/uploadFile/queryUploadFile'),
      name: 'queryUploadFile',
      meta: { title: '文件上报查询', noCache: true },
      sign: 'currency'
    },
    // {
    //   path: 'uploadFile',
    //   component: () => import('@/views/uploadFile/uploadFile'),
    //   name: 'uploadFile',
    //   meta: { title: '上传上报文件', noCache: true },
    //   sign: 'currency'
    // },
    // {
    //   path: 'feedbackFile',
    //   component: () => import('@/views/uploadFile/feedbackFile'),
    //   name: 'feedbackFile',
    //   meta: { title: '反馈文件日志查询', noCache: true },
    //   sign: 'feedback'
    // }
  ]
}

export default uploadRouter
