package com.jiayue.ipfcst.console.job;

import com.jiayue.ipfcst.console.service.BusinessDataBackupService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

/**
 * 业务数据备份定时任务  定时导出气象站 逆变器 风机 测风塔 实际功率
 *
 *  @author whc
 *  @version 3.0
 *  2022-05-05 14:31
 */
@Slf4j
@Service
@EnableScheduling
public class BusinessDataBackupJob {

  @Autowired
  private BusinessDataBackupService businessDataBackupService;
  @Scheduled(cron = "0 1 1 * * *")
  public void fxglFileAnalysis() {

    log.debug("业务数据备份定时任务执行开始");

    this.businessDataBackupService.dataBackup();

    log.debug("业务数据备份定时任务执行完成");

  }
}
