package com.jiayue.ipfcst.dataexchange.dataprocesser.datagainerhandler;


import com.jiayue.ipfcst.dataexchange.exception.DataExchangeException;
import lombok.AllArgsConstructor;
import lombok.Data;

/**
 * 为了组成构建转发数据的  获取器 构造器
 *
 * @author: xiuwei
 */
@Data
@AllArgsConstructor
public abstract class BaseDataGainer<V> {


  /**
   * 期望的数据类型
   */
  NumOrBool expectedType;

  /**
   * 倍率
   */
  Double magnification;

  /**
   * 利用不同的方式获取到数据
   *
   * @return V 指定类型的对象
   * @throws DataExchangeException 自定义异常
   */
  public abstract V getData() throws DataExchangeException;
}
