package com.jiayue.ipfcst.dataexchange.tunnelworker.senders;

import com.jiayue.ipfcst.common.data.entity.ProtocolSenderDataPoint;
import com.jiayue.ipfcst.dataexchange.exception.DataExchangeException;

/**
 * 协议转发数据通道
 *
 * @author 修唯xiuwei
 * @version 3.0
 */

public interface DataSenderInterface {

  /**
   * 更新协议要发送的数据内容
   *
   * @throws DataExchangeException data exchange exception
   */
  void updateData2Protocol() throws DataExchangeException;

  /**
   * 手动置数
   *
   * @param dataPoint 数据点
   * @param value     数值
   * @throws DataExchangeException data exchange exception
   */
  void setValueByManual(ProtocolSenderDataPoint dataPoint,Double value) throws DataExchangeException;


  /**
   * 将转发的数据保存到数据库，先遥信，后遥测，用‘,’分隔
   *
   * @return {@link String}
   */
  String getDataBeingSent();




}
