/** When your routing table is too long, you can split it into small modules**/

import Layout from '@/layout'

const qrCodeQueryRouter = {
  path: '/qrCodeQuery',
  component: Layout,
  redirect: 'noRedirect',
  name: 'qrCodeQuery',
  meta: {
    title: ' 二维码生成',
    icon: 'chart'
  },
  children: [
    {
      path: 'realpowerQrCode',
      component: () => import('@/views/qrcode/realpower'),
      name: 'rpQrCode',
      meta: { title: '实际功率二维码', noCache: true },
      sign: 'currency'
    },
    {
      path: 'environmentQrCode',
      component: () => import('@/views/qrcode/environment'),
      name: 'envQrCode',
      meta: { title: '环境数据二维码', noCache: true },
      sign: 'currency'
    },
  ]
}

export default qrCodeQueryRouter
