/** When your routing table is too long, you can split it into small modules**/

import Layout from '@/layout'

const realTimeQueryRouter = {
  path: '/realTimeQuery',
  component: Layout,
  redirect: 'noRedirect',
  name: 'realTimeQuery',
  meta: {
    title: '实时查询',
    icon: 'chart'
  },
  children: [
    {
      path: 'realPowerQuery',
      component: () => import('@/views/realTimeQuery/realPowerQuery'),
      name: 'realTimeQuery',
      meta: { title: '光伏实际功率查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'realPowerQueryOne',
      component: () => import('@/views/realTimeQuery/realPowerQueryOne'),
      name: 'realTimeQueryOne',
      meta: { title: '风电实际功率查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'weatherStationStatusData',
      component: () => import('@/views/realTimeQuery/weatherStationStatusData'),
      name: 'weatherStationStatusData',
      meta: { title: '气象站查询', noCache: true },
      sign: 'photovoltaic'

    },
    {
      path: 'inverterStatusData',
      component: () => import('@/views/realTimeQuery/inverterStatusData'),
      name: 'inverterStatusData',
      meta: { title: '逆变器查询', noCache: true },
      sign: 'photovoltaic'
    },
    {
      path: 'windTowerStatusData',
      component: () => import('@/views/realTimeQuery/windTowerStatusData'),
      name: 'weatherStationStatusData',
      meta: { title: '测风塔查询', noCache: true },
      sign: 'windPower'

    },
    {
      path: 'windTurbineStatusData',
      component: () => import('@/views/realTimeQuery/windTurbineStatusData'),
      name: 'windTurbineStatusData',
      meta: { title: '风机查询', noCache: true },
      sign: 'windPower'
    },

    {
      path: 'nwp',
      component: () => import('@/views/realTimeQuery/nwp'),
      name: 'nwp',
      meta: { title: '光伏实时NWP查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'nwpOne',
      component: () => import('@/views/realTimeQuery/nwpOne'),
      name: 'nwpOne',
      meta: { title: '风电实时NWP查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'forecastPowerShortTerm16',
      component: () => import('@/views/realTimeQuery/forecastPowerUltraShortTerm16'),
      name: 'forecastPowerShortTerm16',
      meta: { title: '光伏超短期16时刻查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'forecastPowerShortTerm16One',
      component: () => import('@/views/realTimeQuery/forecastPowerUltraShortTerm16One'),
      name: 'forecastPowerShortTerm16One',
      meta: { title: '风电超短期16时刻查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'contrastRealTimeQuery',
      component: () => import('@/views/realTimeQuery/forecastPowerShortTerm'),
      name: 'contrastRealTimeQuery',
      meta: { title: '光伏实时预测查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'contrastRealTimeQueryOne',
      component: () => import('@/views/realTimeQuery/forecastPowerShortTermOne'),
      name: 'contrastRealTimeQueryOne',
      meta: { title: '风电实时预测查询', noCache: true },
      sign: 'currency'
    },
    // {
    //   path: 'contrastReportWindTowerStatusData',
    //   component: () => import('@/views/contrastReportWindTowerStatusData'),
    //   name: 'contrastReportWindTowerStatusData',
    //   meta: { title: '测风塔风速对比查询', noCache: true },
    //   sign: 'currency'
    // },
    // {
    //   path: 'contrastReportWindTowerStatusData',
    //   component: () => import('@/views/contrastReportWindTowerStatusData'),
    //   name: 'contrastReportWindTowerStatusData',
    //   meta: { title: '上报风速对比查询', noCache: true },
    //   sign: 'windPower'
    // },
  ]
}

export default realTimeQueryRouter
