/** When your routing table is too long, you can split it into small modules**/

import Layout from '@/layout'

const statisticsQueryRouter = {
  path: '/statisticsQuery',
  component: Layout,
  redirect: 'noRedirect',
  name: 'statisticsQuery',
  meta: {
    title: ' 统计查询',
    icon: 'tree'
  },
  children: [
    {
      path: 'reportStatistics',
      component: () => import('@/views/statisticsQuery/reportStatistics'),
      name: 'reportStatistics',
      meta: { title: '上报统计查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'accuracyPassRate',
      component: () => import('@/views/statisticsQuery/accuracyPassRate'),
      name: 'accuracyPassRate',
      meta: { title: '光伏准确率日统计查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'accuracyPassRateOne',
      component: () => import('@/views/statisticsQuery/accuracyPassRateOne'),
      name: 'accuracyPassRateOne',
      meta: { title: '风电准确率日统计查询', noCache: true },
      sign: 'currency'
    },
    // {
    //   path: 'accuracyPassRateDay',
    //   component: () => import('@/views/statisticsQuery/accuracyPassRateDay'),
    //   name: 'accuracyPassRateDay',
    //   meta: { title: '准确率日统计查询', noCache: true },
    //   sign: 'currency'
    // },
    {
      path: 'accuracyPassRateMonth',
      component: () => import('@/views/statisticsQuery/accuracyPassRateMonth'),
      name: 'accuracyPassRateMonth',
      meta: { title: '光伏准确率月统计查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'accuracyPassRateMonthOne',
      component: () => import('@/views/statisticsQuery/accuracyPassRateMonthOne'),
      name: 'accuracyPassRateMonthOne',
      meta: { title: '风电准确率月统计查询', noCache: true },
      sign: 'currency'
    },
    // {
    //   path: 'comprehensiveStatistics',
    //   component: () => import('@/views/statisticsQuery/comprehensiveStatistics'),
    //   name: 'comprehensiveStatistics',
    //   meta: { title: '预测发电量统计', noCache: true },
    //   sign: 'currency'
    // },
    {
      path: 'comprehensiveStatisticsQuery',
      component: () => import('@/views/statisticsQuery/CESQuery'),
      name: 'CESQuery',
      meta: { title: '气象站综合统计查询', noCache: true },
      sign: 'currency'
    },
    {
      path: 'comprehensiveStatisticsQueryOne',
      component: () => import('@/views/statisticsQuery/CESQueryOne'),
      name: 'CESQueryOne',
      meta: { title: '测风塔综合统计查询', noCache: true },
      sign: 'currency'
    },
    // {
    //   path: 'throughtTheYearPower',
    //   component: () => import('@/views/statisticsQuery/throughtTheYearPower'),
    //   name: 'throughtTheYearPower',
    //   meta: { title: '全年逐月发电量统计', noCache: true },
    //   sign: 'currency'
    // },
    // {
    //   path: 'integrationStatisticsQuery',
    //   component: () => import('@/views/statisticsQuery/integrationStatistics'),
    //   name: 'integrationStatistics',
    //   meta: { title: '一体化统计查询', noCache: true },
    //   sign: 'photovoltaic'
    // }
  ]
}

export default statisticsQueryRouter
