package com.jiayue.ipfcst.repository;

import com.jiayue.ipfcst.common.data.constant.enums.EquipmentTypeEnum;
import com.jiayue.ipfcst.common.data.entity.EquipmentAttribute;
import com.jiayue.ipfcst.common.data.repository.BaseRepository;

import java.util.List;

/**
 * 采集通道点位表信息仓库
 *
 * @author yh
 * @version 3.0
 */
public interface EquipmentAttributeRepository extends BaseRepository<EquipmentAttribute, Integer> {

  /**
   * 通过name查询点表信息 yh
   *
   * @param name 点位名称
   * @return 对象
   */
  EquipmentAttribute findByFieldName(String name);

  List<EquipmentAttribute> findByEquipmentTypeOrEquipmentType(EquipmentTypeEnum equipmentTypeEnum,EquipmentTypeEnum OrequipmentTypeEnum);

  List<EquipmentAttribute> findByEquipmentType(EquipmentTypeEnum equipmentTypeEnum);



}
