package com.jiayue.ipfcst.repository;

import com.jiayue.ipfcst.common.data.constant.enums.EquipmentTypeEnum;
import com.jiayue.ipfcst.common.data.entity.EquipmentAttribute;
import com.jiayue.ipfcst.common.data.entity.ProtocolGatherDataPoint;
import com.jiayue.ipfcst.common.data.repository.BaseRepository;

import java.util.List;

/**
 * 采集通道点位表信息仓库
 *
 * @author 修唯xiuwei
 * @version 3.0
 */
public interface ProtocolGatherDataPointRepository extends BaseRepository<ProtocolGatherDataPoint, Integer> {
  /**
   * 根据设备编号查询接入数据点位集合
   *
   * @param startOrder 开始点位
   * @param endOrder  结束点位
   * @param id  设备ID
   * @return
   */
   List<ProtocolGatherDataPoint> findByEquipmentAttributeIdBetweenAndEquipmentId(Integer startOrder,Integer endOrder,Integer id);

  /**
   * 根据设备id获取接入数据点位集合
   *
   * @param eqId 设备id
   * @return
   */
   List<ProtocolGatherDataPoint> findByEquipmentIdOrEquipmentId(Integer eqId,Integer orEqId);


  List<ProtocolGatherDataPoint> findByEquipmentAttributeIdIn(Integer[] eqIds);
}
